## Copyright (C) 2011-2012 Carnë Draug <carandraug+dev@gmail.com>
##
## This program is free software; you can redistribute it and/or modify it under
## the terms of the GNU General Public License as published by the Free Software
## Foundation; either version 3 of the License, or (at your option) any later
## version.
##
## This program is distributed in the hope that it will be useful, but WITHOUT
## ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
## details.
##
## You should have received a copy of the GNU General Public License along with
## this program; if not, see <http://www.gnu.org/licenses/>.

function ret = subsref (inPar, idx)

  _inPar = _inputParserStore ('pull', inPar.counter);

  _ret = subsref (_inPar, idx);

  if ~isa(_ret, '_inputParser')
    ret = _ret;
    return;
  endif

  method = idx(1).subs;
  if strcmpi(method, 'createCopy')
    counter = getfield(inputParser(), 'counter');
  else
    counter = inPar.counter;
  endif
  
  _inPar = _ret;
  _inputParserStore ('push', counter, _inPar);
  inPar = struct('counter',counter);
  inPar = class (inPar, 'inputParser');
  ret = inPar;
  
endfunction

